set echo on
set timing off
--
-- New use of Oracle Outer Join operator
--
select region_name, country_name, department_name, city, count(employee_id) nbr_emps
  from hr.regions r, hr.countries c, hr.locations l, hr.departments d, hr.employees e
  where r.region_id = c.region_id(+)
    and c.country_id = l.country_id(+)
    and l.location_id = d.location_id(+)
    and d.department_id = e.department_id(+)
    group by region_name,country_name,department_name, city
    order by region_name,country_name,department_name, city;
--
--
-- Using JOIN with Collection object CROSS APPLY  OUTER APPLY
--
create or replace type name_table_type as table of varchar2(100);
/
create or replace function department_employees (in_department_id varchar2)
   return name_table_type
is
  mynames name_table_type;
begin
  select cast(collect(last_name || ', ' || first_name) 			as name_table_type)
     into mynames
     from hr.employees
     where department_id = in_department_id;
  return mynames;
end;
/
select *
  from hr.departments d
       cross apply
       department_employees(d.department_id) dept_emps;
select *
  from hr.departments d
       outer apply
       department_employees(d.department_id) dept_emps;
select department_name
      ,department_employees(department_id) deptemps
  from hr.departments;
--
--
select prod_id,trunc(time_id) time_id,round(sum(amount_sold)) amount_sold from sh.sales where prod_id = 148 and extract(year from time_id) in (2000,2001) group by prod_id, trunc(time_id)
order by prod_id,trunc(time_id);
--
--
-- LATERAL inline views
--
-- this should cause error; fixed by addition of LATERAL below
select last_name,first_name,department_name
   from hr.employees e, (select * from hr.departments d where e.department_id = d.department_id);
--
select last_name,first_name,department_name
   from hr.employees e, LATERAL(select * from hr.departments d where e.department_id = d.department_id);
--
