create or replace procedure Print_Call_Stack
    is
  begin
      dbms_output.put_line(DBMS_Utility.Format_Call_Stack());
end;
/
create or replace procedure Print_Call_Stack
    as
      DEPTH pls_integer := UTL_CALL_STACK.dynamic_depth();
    
      procedure printheaders
      is
      begin
        dbms_output.put_line( 'Lexical   Depth   Line    Name' );
        dbms_output.put_line( 'Depth             Number      ' );
        dbms_output.put_line( '-------   -----   ----    ----' );
     end printheaders;
     procedure print
     is
     begin
         printheaders;
         for stackunit in reverse 1..DEPTH loop
           dbms_output.put_line(
             rpad( UTL_CALL_STACK.lexical_depth(stackunit), 10 ) ||
                     rpad( stackunit, 7) ||
             rpad( To_Char(UTL_CALL_STACK.unit_line(stackunit), '99'), 9 ) ||
             UTL_CALL_STACK.concatenate_subprogram
                        (UTL_CALL_STACK.subprogram(stackunit)));
         end loop;
     end;
   begin
     print;
end;
/
--
create or replace package TestPkg is
    procedure proc_a;
end TestPkg;
/ 
create or replace
    package body TestPkg is
      procedure proc_a
      is
        procedure proc_b
        is
          procedure proc_c
          is
            procedure proc_d is
           begin
             Print_Call_Stack();
             raise program_error;
           end proc_d;
         begin
           proc_d();
         end proc_c;
       begin
         proc_c();
       end proc_b;
     begin
       proc_b();
     end proc_a;
   end TestPkg;
/
--
pause
--
begin TestPkg.proc_a; end;