-- JSON Select generate JSON
--
-- JSON_OBJECT
SELECT json_object('empId'       VALUE employee_id
                   , 'empName'     VALUE last_name || ', ' || first_name
                   , 'phoneNumber' VALUE phone_number
                   , 'deptId'  VALUE department_id
                   , 'pay'  value json_object('salary' value salary, 'commPct' value commission_pct)
                                        FORMAT JSON) emp_rows
   FROM hr.employees
   WHERE department_id < 30;
--
-- Absent on NULL
select json_object('empId'       value employee_id
                    , 'empName'     value last_name || ', ' || first_name
                    , 'phoneNumber' value phone_number
                    , 'deptId'  value department_id
                    , 'pay'  value json_object('salary' value salary, 'commPct' value commission_pct absent on null)
                                         FORMAT JSON) emp_rows
    from hr.employees
    where department_id < 30;
--
-- JSON_ARRAY
select json_object('employeeIdId' value employee_id
                  , 'empName'     value last_name || ', ' || first_name
                  , 'phoneNumber' value phone_number
                  , 'deptId'  value department_id
                  ,'pay' value json_array(salary,commission_pct)) json_output
  from hr.employees
  where commission_pct is not null and salary < 6500;
--
-- JSON_OBJECTAGG
select json_objectagg( last_name || ', ' || first_name value salary) json_output
  from hr.employees
  where department_id < 50;
--
-- JSON_ARRAYAGG
select json_object('departmentName' value department_name
                  , 'deptId'  value depts.department_id
                  , 'numberEmps' value count(emps.employee_id)
                  , 'deptEmps' value json_arrayagg( last_name || ', ' || first_name
                        order by last_name,first_name)) json_output
  from hr.employees emps join hr.departments depts
     on depts.department_id = emps.department_id
  where salary < 6500
  group by depts.department_name,depts.department_id
  order by depts.department_name;
--
