/*
 * Java application using Oracle "thin" driver
 * Net8/SQL*Net not required on client
 *
 * Sample use of Oracle Stored Procedure and Function
 * via JDBC
 *
 * @version 1.01 04/01/2000
 * @author  John Jay King
 */

package samples;
import java.sql.*;	// needed for JDBC
import java.math.*; // needed for bigDecimal

/** Sample use of Oracle "thin" JDBC connection */
public class OraThinJDBCStoredProcImplicitResult
{
  public static void main (String args [])
       throws SQLException
  {
    // Load the Oracle JDBC driver
    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());

    // Connect to the database, connection string format:
    // 	jdbc:oracle:thin:@**hostcomputer**:**port**:**oraclesid**
    Connection conn =
      DriverManager.getConnection ("jdbc:oracle:thin:@192.168.0.61:1539/pdb1.localdomain",
				   "john", "king");

    // Create a Statement
    CallableStatement stmt1 = conn.prepareCall("{CALL my_implicit_table(?)}");
    ResultSet rs1 = null;
    stmt1.setInt(1,20);
    stmt1.executeQuery();
//    System.out.println("Value returned is " + stmt1.getString(3));
    int nbrrows = 0;
    while (stmt1.getMoreResults()) {
          rs1= stmt1.getResultSet();
          System.out.println("ResultSet");
          while (rs1.next()) {
        	  System.out.println("nbrrows="+ ++nbrrows);
        	  System.out.println("Employee " + rs1.getInt("empno") 
        			  + " is " + rs1.getString("ename")
        			  + " works as " + rs1.getString("job")
        			  + " and makes " + rs1.getDouble("sal"));
         }
     }

 	 stmt1.close();

	 // Close connection
	 conn.close();
  } // end main
} // end OraThinJDBCStoredProc